'  2313
'  .. 07.04.2020


$regfile = "attiny2313.dat"
$crystal = 8000000
$hwstack = 32
$swstack = 8
$framesize = 24


Dim Wh As Byte                          '   
Dim Wl As Byte                          '   
Dim Led As Byte                         '  LED
Dim Cont As Byte                        '    
Dim Cont2 As Byte                       '   
Dim Flag As Bit                         '    
Dim Status As Bit                       '  
Dim Poweroff As Integer                 '   

Ed Alias Portd.1                        '  
Des Alias Portd.0                       '  
Switch Alias Pind.3                     ' 

Const Cycle = 100                       '     
Const Timework = 240                    '  ()    


'============================================================================
Ddrb = &HFF                             '  
Ddrd = &B11                             '  
Set Portd.3                             '    SB

Ocr1a = 800                             '  1
Config Timer1 = Timer , Prescale = 64
Config Int0 = Falling                   '      
Config Int1 = Low Level                 '   
Config Aci = Off                        '    

Enable Compare1a                        ' 
Enable Timer1
Enable Int0
Enable Int1
                                         '   
On Int0 Takt                            '  
On Compare1a End_takt                   '  
On Timer1 Finish                        ' .    ,    --
On Int1 Pitanie                         '     Powerdown

Enable Interrupts                       '  

Status = 1
Wh = 10                                 '    --  
Wl = Wh
Cont = 0                                '  
Cont2 = Cont
Reset Flag
Poweroff = Timework * Cycle             '     

' =====================     =====================
Do
If Wh > 0 Then                          '      
   Led = Lookup(wh , Seg)               '         7
   Portb = Led                          '   
Else
   Portb = 0                            '      
End If

Des = 1                                 '    
Waitms 5
Des = 0                                 '    

Led = Lookup(wl , Seg)                  '    
Portb = Led
Ed = 1
Waitms 5
Ed = 0

Poweroff = Poweroff - 1                 ' -        
If Poweroff = 0 Then                    '  -  
   Status = 0
End If

If Status = 0 Then                      '   =0     Powerdown
      Portb = 0                         ' 
      Ed = 0 : Des = 0
      Config Int0 = Low Level
      Powerdown
      Status = 1
      Poweroff = Timework * Cycle
      Config Int0 = Falling
End If
Loop

'===============  =======================================
Takt:                                   '  
If Flag = 1 Then                        '     
   If Cont = Cont2 Then                 '    , 
      Wh = Cont / 10                    '    
      Wl = Cont Mod 10
   Else
      Cont2 = Cont
   End If
   Reset Flag                           ' 
   Cont = 0
End If
Cont = Cont + 1
Poweroff = Timework * Cycle             '    
Tcnt1 = 0                               ' 
Start Timer1
Return
'--------------------------------------------------------------------
End_takt:                               '  .   
If Cont > 0 Then
  Set Flag
End If
Return
'--------------------------------------------------------------------
Finish:                                 '   .
   Cont = 0                             ' ,    --
   Wh = 10
   Wl = Wh
  Stop Timer1                           ' 
  Tcnt1 = 0
Return
'--------------------------------------------------------------------
Pitanie:                                '- 
 Waitms 100
 Do : Loop Until Switch = 1             '  
 Waitms 100
 Toggle Status                          '   
Return
'--------------------------------------------------------------------
Seg:                                    '    324

Data &B11101101                         ' / / 0
Data &B01000100                         ' / / 1
Data &B00101111                         ' / / 2
Data &B01100111                         ' / / 3
Data &B11000110                         ' / / 4
Data &B11100011                         ' / / 5
Data &B11101011                         ' / / 6
Data &B01000101                         ' / / 7
Data &B11101111                         ' / / 8
Data &B11100111                         ' / / 9
Data &B00000010                         ' / / -